## ros-noetic-dynamic-graph 4.4.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

# Project properties
set(PROJECT_ORG stack-of-tasks)
set(PROJECT_NAME dynamic-graph)
set(PROJECT_DESCRIPTION "Dynamic graph library")
set(PROJECT_URL "https://github.com/${PROJECT_ORG}/${PROJECT_NAME}")

# Project options
option(SUFFIX_SO_VERSION "Suffix library name with its version" ON)

# Project configuration
set(PROJECT_USE_CMAKE_EXPORT TRUE)
set(CUSTOM_HEADER_DIR ${PROJECT_NAME})
set(CXX_DISABLE_WERROR TRUE)

# Doxygen setup
set(DOXYGEN_USE_MATHJAX YES)
set(DOXYGEN_USE_TEMPLATE_CSS YES)

# JRL-cmakemodule setup
include(cmake/base.cmake)
include(cmake/boost.cmake)

# Project definition
compute_project_args(PROJECT_ARGS LANGUAGES CXX)
project(${PROJECT_NAME} ${PROJECT_ARGS})
check_minimal_cxx_standard(14 ENFORCE)

include(cmake/pthread.cmake) # needs to be included after the CXX definition

# Project dependencies
if(BUILD_TESTING)
  find_package(Boost REQUIRED COMPONENTS unit_test_framework)
endif()
add_project_dependency(Boost REQUIRED COMPONENTS serialization system thread)
add_project_dependency(Eigen3 REQUIRED)
search_for_pthread()

if(Boost_VERSION GREATER 107299 OR Boost_VERSION_MACRO GREATER 107299)
  # Silence a warning about a deprecated use of boost bind by boost >= 1.73
  # without dropping support for boost < 1.73
  add_definitions(-DBOOST_BIND_GLOBAL_PLACEHOLDERS)
endif()

# Add configuration headers for plug-ins.
generate_configuration_header(${HEADER_DIR} config-tracer.hh DG_TRACER
                              tracer_EXPORTS)
generate_configuration_header(${HEADER_DIR} config-tracer-real-time.hh
                              DG_TRACERREALTIME tracer_real_time_EXPORTS)

# Verbosity level
if(NOT (\"${CMAKE_VERBOSITY_LEVEL}\" STREQUAL \"\"))
  add_definitions(-DVP_DEBUG_MODE=${CMAKE_VERBOSITY_LEVEL} -DVP_DEBUG)
endif(NOT (\"${CMAKE_VERBOSITY_LEVEL}\" STREQUAL \"\"))

# Main Library
set(${PROJECT_NAME}_HEADERS
    include/${CUSTOM_HEADER_DIR}/fwd.hh
    include/${CUSTOM_HEADER_DIR}/debug.h
    include/${CUSTOM_HEADER_DIR}/real-time-logger.h
    include/${CUSTOM_HEADER_DIR}/real-time-logger-def.h
    include/${CUSTOM_HEADER_DIR}/dynamic-graph-api.h
    include/${CUSTOM_HEADER_DIR}/entity.h
    include/${CUSTOM_HEADER_DIR}/factory.h
    include/${CUSTOM_HEADER_DIR}/pool.h
    include/${CUSTOM_HEADER_DIR}/exception-abstract.h
    include/${CUSTOM_HEADER_DIR}/exception-factory.h
    include/${CUSTOM_HEADER_DIR}/exception-signal.h
    include/${CUSTOM_HEADER_DIR}/exception-traces.h
    include/${CUSTOM_HEADER_DIR}/signal.h
    include/${CUSTOM_HEADER_DIR}/signal-array.h
    include/${CUSTOM_HEADER_DIR}/signal-base.h
    include/${CUSTOM_HEADER_DIR}/signal-ptr.h
    include/${CUSTOM_HEADER_DIR}/signal-time-dependent.h
    include/${CUSTOM_HEADER_DIR}/signal-ptr.t.cpp
    include/${CUSTOM_HEADER_DIR}/signal.t.cpp
    include/${CUSTOM_HEADER_DIR}/time-dependency.h
    include/${CUSTOM_HEADER_DIR}/time-dependency.t.cpp
    # Kept for a brittle backward compatiblity.
    include/${CUSTOM_HEADER_DIR}/signal-caster.h
    include/${CUSTOM_HEADER_DIR}/signal-cast-helper.h
    include/${CUSTOM_HEADER_DIR}/all-signals.h
    include/${CUSTOM_HEADER_DIR}/signal-helper.h
    include/${CUSTOM_HEADER_DIR}/entity-helper.h
    include/${CUSTOM_HEADER_DIR}/tracer.h
    include/${CUSTOM_HEADER_DIR}/tracer-real-time.h
    include/${CUSTOM_HEADER_DIR}/command.h
    include/${CUSTOM_HEADER_DIR}/eigen-io.h
    include/${CUSTOM_HEADER_DIR}/linear-algebra.h
    include/${CUSTOM_HEADER_DIR}/value.h
    include/${CUSTOM_HEADER_DIR}/command-setter.h
    include/${CUSTOM_HEADER_DIR}/command-setter.t.cpp
    include/${CUSTOM_HEADER_DIR}/command-getter.h
    include/${CUSTOM_HEADER_DIR}/command-getter.t.cpp
    include/${CUSTOM_HEADER_DIR}/command-direct-getter.h
    include/${CUSTOM_HEADER_DIR}/command-direct-setter.h
    include/${CUSTOM_HEADER_DIR}/command-bind.h
    include/${CUSTOM_HEADER_DIR}/all-commands.h
    include/${CUSTOM_HEADER_DIR}/logger.h)

set(${PROJECT_NAME}_SOURCES
    src/debug/debug.cpp
    src/debug/real-time-logger.cpp
    src/debug/logger.cpp
    src/dgraph/entity.cpp
    src/dgraph/factory.cpp
    src/dgraph/pool.cpp
    src/exception/exception-abstract.cpp
    src/exception/exception-factory.cpp
    src/exception/exception-signal.cpp
    src/exception/exception-traces.cpp
    src/mt/process-list.cpp
    src/signal/signal-array.cpp
    src/command/value.cpp
    src/command/command.cpp)

add_library(${PROJECT_NAME} SHARED ${${PROJECT_NAME}_SOURCES}
                                   ${${PROJECT_NAME}_HEADERS})
modernize_target_link_libraries(
  ${PROJECT_NAME}
  SCOPE
  PUBLIC
  TARGETS
  Eigen3::Eigen
  INCLUDE_DIRS
  ${EIGEN3_INCLUDE_DIR})
target_include_directories(${PROJECT_NAME} PUBLIC $<INSTALL_INTERFACE:include>)
target_link_libraries(${PROJECT_NAME} PUBLIC Boost::serialization Boost::system
                                             Boost::thread)

if(UNIX)
  target_link_libraries(${PROJECT_NAME} PUBLIC ${CMAKE_DL_LIBS} pthread)
endif(UNIX)

if(SUFFIX_SO_VERSION)
  set_target_properties(${PROJECT_NAME} PROPERTIES SOVERSION ${PROJECT_VERSION})
endif(SUFFIX_SO_VERSION)

install(
  TARGETS ${PROJECT_NAME}
  EXPORT ${TARGETS_EXPORT_NAME}
  DESTINATION lib)

set(DYNAMIC_GRAPH_PLUGINDIR "lib/${PROJECT_NAME}-plugins")
set(PACKAGE_EXTRA_MACROS
    "set(DYNAMIC_GRAPH_PLUGINDIR ${DYNAMIC_GRAPH_PLUGINDIR})")
set(PKG_CONFIG_EXTRA "plugindir=${DYNAMIC_GRAPH_PLUGINDIR}")

add_subdirectory(src)
if(BUILD_TESTING)
  add_subdirectory(tests)
endif(BUILD_TESTING)

pkg_config_append_libs(${PROJECT_NAME})
install(FILES package.xml DESTINATION share/${PROJECT_NAME})

=== src/CMakeLists.txt ===
set(CMAKE_BUILD_WITH_INSTALL_RPATH TRUE)

set(plugins traces/tracer traces/tracer-real-time)

set(tracer-real-time_deps tracer)

foreach(plugin ${plugins})
  get_filename_component(LIBRARY_NAME ${plugin} NAME)
  add_library(${LIBRARY_NAME} SHARED "${plugin}.cpp")

  if(SUFFIX_SO_VERSION)
    set_target_properties(${LIBRARY_NAME} PROPERTIES SOVERSION
                                                     ${PROJECT_VERSION})
  endif(SUFFIX_SO_VERSION)
  set_target_properties(${LIBRARY_NAME} PROPERTIES INSTALL_RPATH $ORIGIN)

  target_link_libraries(${LIBRARY_NAME} PUBLIC ${PROJECT_NAME}
                                               ${${LIBRARY_NAME}_deps})

  install(
    TARGETS ${LIBRARY_NAME}
    EXPORT ${TARGETS_EXPORT_NAME}
    DESTINATION ${DYNAMIC_GRAPH_PLUGINDIR})
endforeach(plugin)

=== tests/CMakeLists.txt ===
# Copyright 2010-2020, Olivier Stasse, Guilhem Saurel, JRL, CNRS/AIST, LAAS-CNRS

add_definitions(-DBOOST_TEST_DYN_LINK -DBOOST_TEST_MAIN)

add_definitions(-DTESTS_DATADIR="${CMAKE_CURRENT_SOURCE_DIR}/data")
add_definitions(-DTESTS_PLUGINDIR="${LIBRARY_OUTPUT_PATH}")
add_definitions(-DTESTS_DYNLIBSUFFIX="${CMAKE_SHARED_LIBRARY_SUFFIX}")

macro(DYNAMIC_GRAPH_TEST NAME)
  add_unit_test(${NAME} "${NAME}.cpp")
  target_link_libraries(${NAME} PRIVATE ${PROJECT_NAME}
                                        Boost::unit_test_framework)
endmacro(DYNAMIC_GRAPH_TEST)

# Signal cast test.
set(signalcast_libs signal-cast-registerer-libA signal-cast-registerer-libB)

foreach(lib ${signalcast_libs})
  add_library(${lib} SHARED "${lib}.cpp")
  target_link_libraries(${lib} PRIVATE ${PROJECT_NAME})
endforeach()

dynamic_graph_test(signal-cast-registerer)

# Unit testing.
if(NOT APPLE)
  dynamic_graph_test(entity)
endif(NOT APPLE)
dynamic_graph_test(custom-entity)
dynamic_graph_test(factory)
dynamic_graph_test(pool)
dynamic_graph_test(signal-time-dependent)
dynamic_graph_test(value)
dynamic_graph_test(signal-ptr)
dynamic_graph_test(real-time-logger)
dynamic_graph_test(debug-trace)
dynamic_graph_test(debug-tracer)
target_link_libraries(debug-tracer PRIVATE tracer)
dynamic_graph_test(debug-real-time-tracer)
target_link_libraries(debug-real-time-tracer PRIVATE tracer-real-time tracer)
dynamic_graph_test(debug-logger)
dynamic_graph_test(debug-logger-winit)
dynamic_graph_test(signal-all)
dynamic_graph_test(command-test)
dynamic_graph_test(test-mt)
target_link_libraries(test-mt PRIVATE tracer)
dynamic_graph_test(exceptions)

=== debian/changelog ===
ros-noetic-dynamic-graph (4.4.3-2buster) buster; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Guilhem saurel <guilhem.saurel@laas.fr>  Wed, 07 Sep 2022 12:29:00 -0000

=== debian/control ===
Source: ros-noetic-dynamic-graph
Section: misc
Priority: optional
Maintainer: Guilhem saurel <guilhem.saurel@laas.fr>
Build-Depends: debhelper (>= 9.0.0), cmake, doxygen, git, graphviz, libboost-all-dev, libeigen3-dev
Homepage: http://github.com/stack-of-tasks/dynamic-graph
Standards-Version: 3.9.2

Package: ros-noetic-dynamic-graph
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, graphviz, libboost-all-dev, libeigen3-dev, ros-noetic-catkin
Description: Dynamic graph library

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

# Solve shlibdeps errors in REP136 packages that use GNUInstallDirs:
export DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/noetic" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-dynamic-graph//opt/ros/noetic/lib/:$(CURDIR)/debian/ros-noetic-dynamic-graph//opt/ros/noetic/lib/${DEB_HOST_MULTIARCH}

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install
